from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from StringIO import StringIO

def install (self):
    
    out = StringIO ()
    
    # Add the necessary actions to the portal form controller
    pfc = getToolByName (self, 'portal_form_controller')
    
    pfc.addFormAction ('base_edit',
                       'success',
                       'RichDocument',
                       'UploadImage',
                       'traverse_to',
                       'string:images_upload')

    pfc.addFormAction ('base_edit',
                       'success',
                       'RichDocument',
                       'ChangeImages',
                       'traverse_to',
                       'string:images_edit')

    pfc.addFormAction ('base_edit',
                       'success',
                       'RichDocument',
                       'MoveImage',
                       'traverse_to',
                       'string:images_move')

    
    pfc.addFormAction ('base_edit',
                       'success',
                       'RichDocument',
                       'DeleteImages',
                       'traverse_to',
                       'string:images_delete')

    print >> out, "Added actions for the image controls to the form controller."

    # Add the fake folder tab
    
    pt = getToolByName (self, 'portal_types')
    
    typeInfo = pt.getTypeInfo ('RichDocument')
    
    numberOfActions = len (typeInfo.listActions ())
    
    typeInfo.addAction ('contents',
        'Contents',
        "python: object.aq_inner.aq_parent.absolute_url () + '/folder_contents'",
        "python: member and member.has_permission ('List folder contents', object.aq_inner.aq_parent) and object.aq_inner.aq_parent.displayContentsTab()",
        "View",
        'object',
        1)
                
    # Move it to the top - our new action has idx 'numberOfActions' initially
    for i in range (0, numberOfActions):
        typeInfo.moveUpActions (((numberOfActions - i),))
    
    print >> out, "Added fake contents-tab action to portal_types/RichDocument"
    
    # This ought not to be necessary, but somehow it ends up in 
    # use_folder_tabs even when hide_folder_tabs set.
    
    pp = getToolByName (self, 'portal_properties')
    
    site_properties = getattr (pp, 'site_properties')
    
    if 'RichDocument' in site_properties.use_folder_tabs:
        new_tabs = list (site_properties.use_folder_tabs)
        new_tabs.remove ('RichDocument')
        
        site_properties.use_folder_tabs = tuple (new_tabs)
    
        print >> out, "Removed RichDocument from use_folder_tabs"
    
     
    if 'RichDocument' in site_properties.typesLinkToFolderContentsInFC:
        types = list (site_properties.typesLinkToFolderContentsInFC)
        types.remove ('RichDocument')
        
        site_properties.typesLinkToFolderContentsInFC = tuple (types)
    
        print >> out, "Removed RichDocument from typesLinkToFolderContentsInFC"
    
    
    return out.getvalue ()

def uninstall (self):

    out = StringIO ()

    pfc = getToolByName (self, 'portal_form_controller')
    
    # There is no Python API for deleting actions or validators in 
    # FormController... 
    
    container = pfc.actions
    
    try:
        container.delete (FormActionKey ('base_edit', 'success', '',
                                            'UploadImage', pfc))
    except KeyError: pass
    
    try:
        container.delete (FormActionKey ('base_edit', 'success', '',
                                            'ChangeImages', pfc))
    except KeyError: pass
    
    try:
        container.delete (FormActionKey ('base_edit', 'success', '',
                                            'MoveImage', pfc))
    except KeyError: pass
    
    try:
        container.delete (FormActionKey ('base_edit', 'success', '',
                                            'DeleteImages', pfc))
    except KeyError: pass
    

    out.write ("Removed actions for RichDocument from the form controller.")
    
    return out.getvalue ()

