## Controller Python Script "images_upload"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=id='',title='', imageTitle=None, imageFile
##title=Edit Images
##

import string
import re

# Helper methods
def normalizeString (fileName):
    chars = ''
    for char in fileName:
        if char in string.letters or char in ['.', '-'] \
                or char in string.digits:
            chars += char
    return chars
    
def findUniqueId (id):
    contextIds = context.objectIds ()
        
    if id not in contextIds:
        return id
    
    dotDelimited = id.split ('.')
        
    ext = dotDelimited[-1]
    name = '.'.join (dotDelimited[:-1])

    idx = 0
    while (name + '.' + str (idx) + '.' + ext) in contextIds:
        ++idx
        
    return (name + '.' + str (idx) + '.' + ext)
    
        
# Move object out of portal factory if necessary. We can't create images inside
# a folder in the portal factory
new_context = context.portal_factory.doCreate(context, id)

status = 'failure'
message = "You must select an image to upload"

if imageFile:
    
    # Make sure we have a unique file name
    fileName = imageFile.filename

    imageId = ''
    
    if fileName:
        fileName = fileName.split ('/')[-1]
        fileName = fileName.split ('\\')[-1]
        fileName = fileName.split (':')[-1]
        
        imageId = normalizeString (fileName)
                
    if not imageId:
        imageId = normalizeString (imageTitle)
        
    imageId = findUniqueId (imageId)
        
    newImageId = new_context.invokeFactory (id = imageId, type_name = 'Image')
    if newImageId is not None and newImageId != '':
        imageId = newImageId
    
    object = getattr (new_context, imageId, None)
    object.setTitle (imageTitle)
    object.setImage (imageFile)
    status = 'success'
    message = "Image added"
    
return state.set (context = new_context,
                  status = status, 
                  portal_status_message = message)
